#library(urbanR)
#library(RNetCDF)
library(sp)
library(sf)
#library(mapview)
library(ncdf4)
#library(rgeos) 
library(ggplot2)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr 
library(dplyr) 
#library(broom)
#library(magrittr)
library(ggpubr)
library(raster)
#library(rgdal)
#library(tmap)
library(gstat)
library(sp)
library(abind)
library(openair)
library(tidyr)
#library(RColorBrewer)
#library(Metrics)
#library(gbm)
#library(lubridate)
#library(matrixStats)
library(leaflet)
library(viridis)
library(viridisLite)


#open catalonia contour
shp_admin <- read_sf("/home/abarrant/esarchive/scratch/ccarnere/AQS_database/shp/divisions_admin/catalunya/divisions-administratives-v2r1-catalunya-5000-20230928.shp")

#path
path_sp      <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"





### open rds -----------------------------------------------------------------------------
pixels_UK_gbm <- readRDS(paste0(path_sp, "annual_pixels_UK_gbm.rds"))
pixels_UK     <- readRDS(paste0(path_sp, "annual_pixels_UK.rds"))
pixels_count_gbm <- readRDS(paste0(path_sp, "annual_pixels_count_daylimit_UK_GBM.rds"))

pixels_oneday <- readRDS(paste0(path_sp, "pixels_UK_gbm_20190822.rds"))


#un dia
ggplot() + 
  geom_tile(as.data.frame(pixels_oneday), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(6, 16)) +   # limits=c(5, 25)
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )


#annual mean with gbm
ggplot() + 
  geom_tile(as.data.frame(pixels_UK_gbm), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(5, 25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )





#difference between gap filling and not gap filling
df_delta <- as.data.frame(pixels_UK)
df_uk <- as.data.frame(pixels_UK)
df_uk_gbm <- as.data.frame(pixels_UK_gbm)

df_delta$var1.pred <- df_uk_gbm$var1.pred - df_uk$var1.pred


ggplot() + 
  geom_tile(df_delta, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno") +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )



#discrete scale
ggplot() + 
  geom_tile(df_uk, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )

ggplot() + 
  geom_tile(df_uk_gbm, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )


### open netcdf -----------------------------------------------------------------------------

nc_data <- nc_open('/home/abarrant/esarchive/scratch/ccarnere/AQS_database/postprocessed/regional/hourly/sconcno2/sconcno2_2017010100.nc')

lon <- ncvar_get(nc_data, "lon")
lat <- ncvar_get(nc_data, "lat", verbose = F)
t <- ncvar_get(nc_data, "time")  #24 hours

#check to see which value is in the missing data
fillvalue <- ncatt_get(nc_data, "sconcno2", "_FillValue")
#fillvalue

#storing data in 3dim array (lat, lon, time)
sconcno2.array <- ncvar_get(nc_data, "sconcno2") 
dim(sconcno2.array) 

#fill the missing values with NANs in case they werent
sconcno2.array[sconcno2.array == fillvalue$value] <- NA

#selecting an hour
sconcno2.slice <- sconcno2.array[ , ,18]

#convert to raster
r_sconcno2 <- raster(t(sconcno2.slice), xmn=min(lon), xmx=max(lon), ymn=min(lat), ymx=max(lat), crs=CRS("+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs+ towgs84=0,0,0"))
r_sconcno2 <- flip(r_sconcno2, direction='y') 
#plot(r_sconcno2)

#check if they have the same projection, otherwise shp_admin will be transformed to sconcno2 proj
crs_raster <- crs(r_sconcno2)
crs_shapefile <- st_crs(shp_admin) 

if (crs_raster@projargs != crs_shapefile$proj4string) {
  #if CRS is different, reproject shapefile to match raster
  shp_admin <- st_transform(shp_admin, crs = crs_raster@projargs)
}

#convert to dataframe
r_sconcno2_df <- as.data.frame(r_sconcno2, xy = TRUE) 
names(r_sconcno2_df)[3] <- "value" 

ggplot() + 
  geom_tile(data=r_sconcno2_df, aes(x=x, y=y, fill=value)) +
  geom_sf(data=shp_admin, fill=NA, color="white") +
  scale_fill_viridis_c(option="inferno") +   # limits=c(5, 25)
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("NO2\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )

